/*
  За основу взято из: https://alcodistillers.ru/forum/viewtopic.php?id=616 Сообщество винокуров © https://alcodistillers.ru, автор Николя.
 АвтоСамогон, автоматика для самогоноварения и прочего винокурения. 
 Добавлено несколько доработок. Вопросы можно по email:vikm0r@yandex.ru Я не программист, собрал несколько блоков из интернет, изменил, 
 адаптировал и объединил их в одной программе, поэтому за изящество решения не поручусь.
 
 После нажатия кнопки "старт" идет сравнение температуры с датчика и стартовой (образцовой) температуры.
 Если порог не превышен, то открывается клапан с периодичностью от 0 до 8 секунд (в крайних положениях резистора может быть либо 
 полностью закрыт, либо полностью открыт). При срабатывании температурного порога отключения допустима задержка до 8 секунд. 
 Когда превышен порог температуры, то клапан закрывается и отбор спирта прекращается до момента выравнивания температуры с образцовой.
 По нажатию кнопки "меню" можно выбирать поочередно дельту температуры от 0.1 до 0.8 градуса от образцовой температуры.
 Исходный вариант программы был уязвим перед отключением электропитания. Если по какой-то причине выключится и снова включится питание, то 
 значение образцовой температуры обнуляется. Мне это показалось очень неудобным. Чтобы этого избежать, теперь в EEPROM (в энергонезависимую 
 память) записывается это значение. Если электоэнергия выключится и снова включится, то ардуино перезагрузившись продолжит работу
 почти как ни в чем не бывало. 
 10-й пин - датчик температуры с доп. резистором.
 Аналоговые выводы А4 - SDA I2C-индикатора, А5 - SCL
 2 пин - кнопка "старт"
 13 пин - светодиод кнопки "старт"
 5 пин - кнопка "шаг"
 12 пин - светодиод кнопки "шаг"
 3 пин - можно подключить реле без ШИМ-регулировки. Будет срабатывать только от превышения температурного порога (как в исходном варианте).
 7 пин - реле, которое срабатывает от ШИМ (можно светодиод добавить)
 Аналоговый выход А0 - к центральному выводу переменного резистора 10к (можно большего номинала). Крайние выводы резистора - к +5в. и к GND
 Нагрев у меня осуществляется на газовой плите, поэтому ничего не добавлял для регулировки, или отключения ТЭНов.
 */

#include <Wire.h>
#include <EEPROM2.h>
#include <OneWire.h> 
OneWire ds(10); // датчик к 10 цифровому пину 

// Для дисплея 
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,16,2); // инициализация библиотеки с перечнем задействованных выводов 
/*
Подключаем LCD индикатор по I2C к следующим выводам:
 ---------------------------------
 Arduino Nano   	LCD i2c
 ---------------------------------
 GND 	                GND    
 5V 	                VCC    
 A4 	                SDA    
 A5 	                SCL     
 ---------------------------------
 */

float setTmp;     // переменная для заданного значения температуры 
float celsius;     // переменная для текущего значения температуры 
float deltaT;    //переменная для величины превышения температуры (от 0,1 до 0,4 градуса Цельсия)

int buttFixPin = 2; // пин кнопки "Start"
int buttdeltaT = 5;  //кнопка "шаг" изменения температуры на 5 вывод

int buttFixPinCurentState = LOW; // текущее состояние кнопки "Start"
int buttdeltaTCurentState = LOW;           // текущее состояние кнопки "шаг"
const int ledPin = 13; // LED pin кнопки "Start"
const int leddelta = 12; // LED pin кнопки "Шаг"
//int buttonState = 0; // статус кнопки 
int regim=1; 
int flag=0;
//unsigned long time; // объявление переменной time типа unsigned long 

//начальная установка положения клапана
//int rele = 3; // пин кнопки "Klapan"
//int releCurentState = LOW; // текущее состояние кнопки "Klapan"
//digitalWrite(3, LOW); //при включении клапан открыт для отбора "голов"

//Блок для ШИМ начало
boolean metka;
const float pot=0;
uint32_t val, noval = 0;
int ledPin7 = 7;                 // LED подсоединен к выводу 7
unsigned long currentTime;
unsigned long loopTime;
//Блок для ШИМ конец


void setup(void) 

{ 
  pinMode(4, OUTPUT);  //пищалка на выводе 4  

  lcd.init(); 
  lcd.backlight(); 

  pinMode(buttFixPin, INPUT_PULLUP); //подтягиваем входы кнопок к плюсу встроенными резисторами 
  pinMode(buttdeltaT, INPUT_PULLUP); //подтягиваем входы кнопок к плюсу встроенными резисторами
  pinMode(ledPin, OUTPUT); //13й вывод индикация нажатия кнопки
  pinMode(leddelta, OUTPUT); //12й вывод индикация нажатия кнопки
  pinMode(3, OUTPUT); //пин реле клапана отбора напрямую (не использую).

  Serial.begin(9600); 

  //Считаем из постоянной памяти заданную температуру

  //setTmp=EEPROM_read_byte(0); ///////////////////////////////++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  EEPROM_read(0,setTmp);

  //digitalWrite(3, LOW); //при включении клапан открыт для отбора "голов"

  //Блок для ШИМ начало
  pinMode(ledPin7, OUTPUT);      // устанавливаем вывод 7 как выход
  currentTime = millis();       // считываем время, прошедшее с момента запуска программы
  loopTime = currentTime;   
  //Блок для ШИМ конец

} 

void loop(void) 
{ 
  //digitalWrite(3, LOW); //при включении клапан открыт для отбора "голов"
  //time = millis()/1000;   //  не нужно

  //Работа Дисплея 

  //lcd.setCursor(7, 0); 
  lcd.setCursor(0, 0);
  lcd.print("T="); 
  lcd.setCursor(2, 0); // устанавливаем курсор в 1 строке, на 2-ю позицию 
  lcd.print(celsius); // Температура в верхней точке колонны 
  lcd.print((char)223); // Знак градуса 
  lcd.setCursor(11, 1); 

  //lcd.print("V"); 
  //lcd.print(" ");  ///////////////////////////////////----------------------------------++++++++++++++++++++++++++++++++++++++++++++++
  //lcd.print("R");
  lcd.setCursor(12, 1); 
  if (digitalRead(3)) 
    //lcd.print(" ON");

    lcd.print("(*)");

  //lcd.setCursor(15,0); 
  //lcd.print("R");; // показываем состояние выхода 
  //else lcd.print(" OFF");
  else lcd.print("    ");
  //if (digitalRead(3)) 
  lcd.print("  "); 

  //lcd.setCursor(15,0); 
  //if (digitalRead(3)) 
  //lcd.print(" ON");
  //lcd.print("R");; // показываем состояние выхода 
  //else lcd.print(" OFF"); 

  lcd.setCursor(0, 1); // устанавливаем курсор в 0-ом столбце, 3 строка (начинается с 0) 
  lcd.print("Set="); 
  lcd.print(setTmp); // Температура установки
  lcd.print((char)223); // Знак градуса 

  // считываем состояние кнопок 
  buttFixPinCurentState = digitalRead(buttFixPin); 
  buttdeltaTCurentState = digitalRead(buttdeltaT);

  // float celsius=celsius; // переменная для текущего значения температуры 
  // buttonState = digitalRead(buttonPin); 

  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //deltaT = 0.1;    //Начальное значение шага изменения температуры

  if (buttFixPinCurentState == LOW)digitalWrite(ledPin, HIGH ); //Зажигаем светодиод по нажатию кнопки 
  else digitalWrite(ledPin, LOW); 

  //моя вставка
  if (buttdeltaTCurentState == LOW)digitalWrite(leddelta, HIGH ); //Зажигаем светодиод по нажатию кнопки 
  else digitalWrite(leddelta, LOW);
  ////////



  //if (buttFixPinCurentState == LOW && setTmp == 0) {setTmp=celsius; //Если нажата кнопка, пишем в переменную текущее значение температуры 
  if (buttFixPinCurentState == LOW) {
    setTmp=celsius; //Если нажата кнопка, пишем в переменную текущее значение температуры
    lcd.setCursor(11, 1); 
    lcd.print("R");


    //Запись температуры фиксации в переменную
    //EEPROM_write_byte(0, setTmp);            ////////////////////////////+++++++++++++++++++++++++++++++++++++++++++++++++++++++
    EEPROM_write(0, setTmp);
    Serial.println(setTmp);

  } 

  ///*
  //////////////////////////////////////////////////////////////  Моя вставка //////////////////////////////////////////////////////////////
  //     if(digitalRead(14)==HIGH&&flag==0)  //если кнопка нажата   
  if (buttdeltaTCurentState == LOW && flag==0)  //если кнопка нажата (у меня нажатая это LOW, подтянута к питанию моя кнопка)
    // и перемення flag равна 0 , то ... 
  { 
    regim++;   
    flag=1; 

    //это нужно для того что бы с каждым нажатием кнопки 
    //происходило только одно действие 
    // 

    if(regim>8)//ограничим количество режимов 
    { 
      regim=1;//так как мы используем только одну кнопку, 
      // то переключать режимы будем циклично 
    } 

  } 

  //      if(digitalRead(14)==LOW&&flag==1)  //если кнопка НЕ нажата 
  if (buttdeltaTCurentState == HIGH && flag==1)  //если кнопка НЕ нажата (у меня ненажатая это HIGH, подтянута к питанию моя кнопка)
    //и переменная flag равна - 1 ,то ... 
  { 

    flag=0;//обнуляем переменную "knopka" 
  } 



  if(regim==1)//первый режим 
  { 
    //      digitalWrite(9,LOW);//выключаем все светодиоды 
    //      digitalWrite(10,LOW); 

    deltaT = 0.1;  
    //здесь может быть любое ваше действие 

    lcd.setCursor(9, 0); //
    lcd.print("dT+");                
    lcd.setCursor(12, 0); //
    lcd.print(deltaT);                // Выводим на экран индикатор значение дельта Т
    // lcd.setCursor(6, 0); //
    // lcd.print(" ");
    Serial.println(deltaT);
    {
      if (buttdeltaTCurentState == LOW)digitalWrite(leddelta, HIGH ); //Зажигаем светодиод по нажатию кнопки 
      else digitalWrite(leddelta, LOW);
    }
  }

  if(regim==2)//второй режим 
  { 
    //      digitalWrite(10,HIGH);//включае красный светодиод 
    //      digitalWrite(9,LOW); 

    deltaT = 0.2;  
    //здесь может быть любое ваше действие 
    //
    lcd.setCursor(9, 0); //
    lcd.print("dT+");                
    lcd.setCursor(12, 0); //
    lcd.print(deltaT);                // Выводим на экран индикатор значение дельта Т
    // lcd.setCursor(6, 0); //
    // lcd.print(" ");
    Serial.println(deltaT);
    {
      if (buttdeltaTCurentState == LOW)digitalWrite(leddelta, HIGH ); //Зажигаем светодиод по нажатию кнопки 
      else digitalWrite(leddelta, LOW); 
    } 
  } 

  if(regim==3)//третий режим 
  { 

    //      digitalWrite(9,HIGH);//включае зеленый светодиод 
    //      digitalWrite(10,LOW); 

    deltaT = 0.3;  
    //здесь может быть любое ваше действие

    lcd.setCursor(9, 0); //
    lcd.print("dT+");                
    lcd.setCursor(12, 0); //
    lcd.print(deltaT);                // Выводим на экран индикатор значение дельта Т
    // lcd.setCursor(6, 0); //
    // lcd.print(" ");
    Serial.println(deltaT);
    {
      if (buttdeltaTCurentState == LOW)digitalWrite(leddelta, HIGH ); //Зажигаем светодиод по нажатию кнопки 
      else digitalWrite(leddelta, LOW); 
    }
  } 

  if(regim==4)//четвертый режим 
  { 

    deltaT = 0.4;
    //здесь может быть любое ваше действие

    lcd.setCursor(9, 0); //
    lcd.print("dT+");                
    lcd.setCursor(12, 0); //
    lcd.print(deltaT);                // Выводим на экран индикатор значение дельта Т
    // lcd.setCursor(6, 0); //
    // lcd.print(" ");
    Serial.println(deltaT);
    {
      if (buttdeltaTCurentState == LOW)digitalWrite(leddelta, HIGH ); //Зажигаем светодиод по нажатию кнопки 
      else digitalWrite(leddelta, LOW);
    }
  } 

  if(regim==5)  //  5-й режим 
  { 

    deltaT = 0.5;
    //здесь может быть любое ваше действие

    lcd.setCursor(9, 0); //
    lcd.print("dT+");                
    lcd.setCursor(12, 0); //
    lcd.print(deltaT);                // Выводим на экран индикатор значение дельта Т
    // lcd.setCursor(6, 0); //
    // lcd.print(" ");
    Serial.println(deltaT);
    {
      if (buttdeltaTCurentState == LOW)digitalWrite(leddelta, HIGH ); //Зажигаем светодиод по нажатию кнопки 
      else digitalWrite(leddelta, LOW);
    }
  } 

  if(regim==6)  //6-й режим 
  { 

    deltaT = 0.6;
    //здесь может быть любое ваше действие

    lcd.setCursor(9, 0); //
    lcd.print("dT+");                
    lcd.setCursor(12, 0); //
    lcd.print(deltaT);                // Выводим на экран индикатор значение дельта Т
    // lcd.setCursor(6, 0); //
    // lcd.print(" ");
    Serial.println(deltaT);
    {
      if (buttdeltaTCurentState == LOW)digitalWrite(leddelta, HIGH ); //Зажигаем светодиод по нажатию кнопки 
      else digitalWrite(leddelta, LOW);
    }
  } 

  if(regim==7)  //  7-й режим 
  { 

    deltaT = 0.7;
    //здесь может быть любое ваше действие

    lcd.setCursor(9, 0); //
    lcd.print("dT+");                
    lcd.setCursor(12, 0); //
    lcd.print(deltaT);                // Выводим на экран индикатор значение дельта Т
    // lcd.setCursor(6, 0); //
    // lcd.print(" ");
    Serial.println(deltaT);
    {
      if (buttdeltaTCurentState == LOW)digitalWrite(leddelta, HIGH ); //Зажигаем светодиод по нажатию кнопки 
      else digitalWrite(leddelta, LOW);
    }
  } 

  if(regim==8)  //  8-й режим 
  { 

    deltaT = 0.8;
    //здесь может быть любое ваше действие

    lcd.setCursor(9, 0); //
    lcd.print("dT+");                
    lcd.setCursor(12, 0); //
    lcd.print(deltaT);                // Выводим на экран индикатор значение дельта Т
    // lcd.setCursor(6, 0); //
    // lcd.print(" ");
    Serial.println(deltaT);
    {
      if (buttdeltaTCurentState == LOW)digitalWrite(leddelta, HIGH ); //Зажигаем светодиод по нажатию кнопки 
      else digitalWrite(leddelta, LOW);
    }
  } 
  ////////////////////////////////////////////////////////////// конец моей вставки ///////////////////////////////////////////////////////////
  //*/


  //if (celsius > (setTmp+0.1))digitalWrite(3, HIGH ); // Если температура выше зафиксированной на 0,1 С, клапан закрыт 
  if (celsius > (setTmp+deltaT))digitalWrite(3, HIGH ) ;// Если температура выше зафиксированной на значение "deltaT" С, клапан закрыт
  // metka = true;
  else digitalWrite(3, LOW); //иначе, открыт

  // Блок для ШИМ (срабатывает метка при повышении температуры)
  if (celsius > (setTmp+deltaT))metka = true; 
  else (metka = false);     
  //Конец блока для ШИМ 

  byte i; 
  byte type_s; 
  byte data[12]; 
  byte addr[8]; 
  // Ищем адрес датчика 
  if ( !ds.search(addr)) 
  { 
    ds.reset_search(); 
    delay(250); 
    return; 
  } 
  // Проверяем не было ли помех при передаче 
  if (OneWire::crc8(addr, 7) != addr[7]) 
  { 
    Serial.println("CRC is not valid!"); 
    return; 
  } 
  Serial.println(); 
  // Определяем серию датчика 
  switch (addr[0]) 
  { 
  case 0x10: 
    Serial.println(" RECTIFICAT"); 
    type_s = 1; 
    break; 
  case 0x28: 
    Serial.println(" CRECTIFICAT"); 
    type_s = 0; 
    break; 
  case 0x22: 
    Serial.println(" RECTIFICAT"); 
    type_s = 0; 
    break; 
  default: 
    Serial.println("Device is not a DS18x20 family device."); 
    return; 
  } 
  ds.reset(); 
  ds.select(addr); // Выбираем адрес 
  ds.write(0x44, 1); // Производим замер, в режиме паразитного питания 
  delay(750); 
  ds.reset(); 
  ds.select(addr); 
  ds.write(0xBE); // Считываем оперативную память датчика 
  for ( i = 0; i < 9; i++) 
  { 
    data[i] = ds.read(); // Заполняем массив считанными данными 
  } 
  // Данные о температуре содержатся в первых двух байтах, переведем их в одно значение и преобразуем в шестнадцатиразрядное число 
  int16_t raw = (data[1] << 8) | data[0]; 
  if (type_s) { 
    raw = raw << 3; 
    if (data[7] == 0x10) 
    { 
      raw = (raw & 0xFFF0) + 12 - data[6]; 
    } 
  } 
  else { 
    byte cfg = (data[4] & 0x60); 
    if (cfg == 0x00) raw = raw & ~7; 
    else if (cfg == 0x20) raw = raw & ~3; 
    else if (cfg == 0x40) raw = raw & ~1; 
  } 
  celsius = (float)raw / 16.0; 
  Serial.print("T = "); 
  Serial.print(celsius); 
  Serial.print(" C  "); 
  Serial.print("setTmp "); 
  Serial.print(setTmp); 
  Serial.print("  deltaT "); 
  Serial.print(deltaT); 

  /////##################################################################################################
  //Блок для ШИМ

  float val = analogRead(pot);     //Присваиваем переменной, ответственной за включение, значение от угла поворота резистора.
  //Период, когда клапан включен (Весь угол поворота резистора равен значению от 0 до 1023).
  val = val * 8;                  //Увеличиваем скважность регулировки клапана до 8 секунд.
  noval = (1023*8 - val);         //Период, когда клапан выключен. Он равен значению остаточного сектора поворота резистора. 

  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  currentTime = millis();                                          // считываем время, прошедшее с момента запуска программы
  if(currentTime >= (loopTime + val+noval) && (metka == false)){  // сравниваем текущий таймер с переменной loopTime и с меткой повышения температуры
    digitalWrite(ledPin7, HIGH);                                  // включаем LED (клапан)
    loopTime = currentTime;                                       // в loopTime записываем новое значение
  }
  currentTime = millis();                                         // считываем время, прошедшее с момента запуска программы
  if(currentTime >= (loopTime + noval)){                          // сравниваем текущий таймер с переменной loopTime
    digitalWrite(ledPin7, LOW);                                     // выключаем LED (клапан)
    //   loopTime = currentTime;                                      // 
  }
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  if ((val/8 <= 1) && (metka == false))  digitalWrite(ledPin7, HIGH);     // включаем клапан в крайнем левом положении резистора + если метка повышения температуры сработала
  if (val/8 >= 1022) digitalWrite(ledPin7, LOW);                          // выключаем клапан в крайнем левом положении резистора
  //Блок ШИМ конец


}
//За основу взято из: https://alcodistillers.ru/forum/viewtopic.php?id=616 Сообщество винокуров © https://alcodistillers.ru
// Добавлено меню выбора пределов срабатывания автоматики (поочередное нажатие кнопки): через 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8 градуса.
// И добавлен "ШИМ" для клапана отбора. Срабатывает в диапазоне от 0 до 5 секунд с плавно регулируемой скважностью.
// Так же, в EEPROM сохраняется образцовая температура. Если перезагрузится ардуино, то ничего страшного не случится, работа автоматики возобновится.
// Вопросы можно по email:vikm0r@yandex.ru
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


